/*
** Copyright (C) 2012 Lacroix Thomas
** 
** This program is free software; you can redistribute it and/or
** modify it under the terms of the GNU Lesser General Public
** License as published by the Free Software Foundation; either
** version 2.1 of the License, or (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
** Lesser General Public License for more details.
** 
** You should have received a copy of the GNU Lesser General Public
** License along with this program; if not, write to the Free Software
** Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
*/

#include <cmath>
#include "AABB.h"

// Lire le .pdf dans "../doc" pour plus d'infos

AABB::AABB(double oX, double oY, double w, double h)
	: oX(oX), oY(oY), w(w), h(h)
{
}

AABB::~AABB(void)
{
}

// Change la position
void AABB::setPosition(double new_oX, double new_oY)
{
	oX = new_oX;
	oY = new_oY;
}

// Change la largeur
void AABB::SetWidth(double new_w)
{
	w = new_w;
}

// Change la hauteur
void AABB::SetHeight(double new_h)
{
	h = new_h;
}

// Dfinie si il y a collision entre deux AABB
bool Collision(AABB* pRect1, AABB* pRect2)
{
	double offsetX1 = pRect1->oX - pRect1->w/2.;
	double offsetY1 = pRect1->oY - pRect1->h/2.;
	double offsetX2 = pRect2->oX - pRect2->w/2.;
	double offsetY2 = pRect2->oY - pRect2->h/2.;
	return !(offsetX1 > offsetX2 + pRect2->w
		  || offsetY1 > offsetY2 + pRect2->h
		  || offsetX2 > offsetX1 + pRect1->w
		  || offsetY2 > offsetY1 + pRect1->h);
}
