/*
** Copyright (C) 2012 Lacroix Thomas
** 
** This program is free software; you can redistribute it and/or
** modify it under the terms of the GNU Lesser General Public
** License as published by the Free Software Foundation; either
** version 2.1 of the License, or (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
** Lesser General Public License for more details.
** 
** You should have received a copy of the GNU Lesser General Public
** License along with this program; if not, write to the Free Software
** Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
*/

#pragma once
#include <SFML\Graphics.hpp>
#include "Defines.h"
#include "ImgAnim.h"
#include "TileMap.h"
#include "Tank.h"
#include "OBB.h"

class Tank;

class Bomb : public ImgAnim
{
public:
	Bomb(sf::Texture *texture, TileMap *map, unsigned int w, unsigned int h, unsigned int maxh, unsigned int damages, float speed);
	virtual ~Bomb(void);

	// Mise  jour de la bombe / missile (colisions)
	void Update(float timeFactor, Tank& enemyTank);

	// Proprits publiques de la bombe / missile
	bool m_isAlive; // Missile  supprimer (ex: hors cran)
	float m_speed;
	sf::Clock m_animClock;

private:
	// Proprits (privs) de la bombe / missile
	unsigned int m_w;
	unsigned int m_h;
	unsigned int m_maxh;
	unsigned int m_damages;

	// TileMap pour les collisions
	TileMap *m_map;
};

