/*
** Copyright (C) 2012 Lacroix Thomas
** 
** This program is free software; you can redistribute it and/or
** modify it under the terms of the GNU Lesser General Public
** License as published by the Free Software Foundation; either
** version 2.1 of the License, or (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
** Lesser General Public License for more details.
** 
** You should have received a copy of the GNU Lesser General Public
** License along with this program; if not, write to the Free Software
** Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
*/

#pragma once

#ifndef PI
#define PI 3.14159265358979323846
#endif

#define DEG_TO_RAD 0.0174532925
#define RAD_TO_DEG 57.29577957

/* Tanks */
const float SPEED = 100.f; // Nb de pixels (dplacement) / seconde
const float SPEED_R = 90.f; // Rotation (nb de degrs) / seconde
const unsigned int TANK_W = 29U;
const unsigned int TANK_H = 24U;
//const unsigned int TANK_LIFE = 2000;

/* Bombes */
const float BOMB_SPEED = 180.f;
const unsigned int BOMB_W = 10U;
const unsigned int BOMB_H = 5U;
const unsigned int BOMB_MH = 11U; // Max height
const unsigned int BOMB_DAMAGES = 190U;

/* Mitrailles */
const float STRAFE_SPEED = 240.f;
const unsigned int STRAFE_W = 9U;
const unsigned int STRAFE_H = 3U;
const unsigned int STRAFE_MH = 3U; // Max height
const unsigned int STRAFE_DAMAGES = 20U;

/* Proprits des tiles */
const unsigned int CELL_SIZE = 30U;

/* Proprits de la fentre */
const unsigned int SCREEN_WIDTH = 35U * CELL_SIZE;
const unsigned int SCREEN_HEIGHT = 25U * CELL_SIZE;