/*
** Copyright (C) 2012 Lacroix Thomas
** 
** This program is free software; you can redistribute it and/or
** modify it under the terms of the GNU Lesser General Public
** License as published by the Free Software Foundation; either
** version 2.1 of the License, or (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
** Lesser General Public License for more details.
** 
** You should have received a copy of the GNU Lesser General Public
** License along with this program; if not, write to the Free Software
** Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
*/

#include "GUI.h"


GUI::GUI(void)
{
}

GUI::~GUI(void)
{
}

const std::string TextBox(sf::RenderWindow &window)
{
	sf::RectangleShape fond(sf::Vector2f(500.f, 350.f));
	fond.setPosition(window.getSize().x / 2.f - fond.getGlobalBounds().width, window.getSize().y / 2.f - fond.getGlobalBounds().height);
	fond.setFillColor(sf::Color::White);
	fond.setOutlineThickness(30.f);
	fond.setOutlineColor(sf::Color::Black);

	sf::Text text;
	text.setPosition(window.getSize().x / 2.f - text.getGlobalBounds().width, window.getSize().y / 2.f - text.getGlobalBounds().height);

	bool continuer = true;
	while (window.isOpen() && continuer)
	{
		sf::Event event;
		while (window.pollEvent(event))
		{
			if (event.type == sf::Event::Closed)
				window.close();
			
			if (event.type == sf::Event::KeyReleased && event.key.code == sf::Keyboard::Return)
				continuer = false;

			if (event.type == sf::Event::KeyReleased && (event.key.code == sf::Keyboard::Num0 || event.key.code == sf::Keyboard::Numpad0))
				text.setString(text.getString() + "0");
		}
		//window.Clear();

		window.draw(fond);
		window.draw(text);

		window.display();
	}
	return text.getString();
}

/*const std::string& TextBoxx(sf::RenderWindow &window)
{
}
*/