/*
** Copyright (C) 2012 Lacroix Thomas
** 
** This program is free software; you can redistribute it and/or
** modify it under the terms of the GNU Lesser General Public
** License as published by the Free Software Foundation; either
** version 2.1 of the License, or (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
** Lesser General Public License for more details.
** 
** You should have received a copy of the GNU Lesser General Public
** License along with this program; if not, write to the Free Software
** Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
*/

#pragma once
#include <SFML\Graphics.hpp>

class ImgAnim : public sf::Sprite
{
public:
	ImgAnim(sf::Texture* texture, int w, int h, bool play = false, float interval = 0.1f);
	virtual ~ImgAnim(void);

	// Contrles
	void Play();
	void Pause();
	void Restart();

	// Paramtres de l'animation
	void SetRow(int row);
	void SetFrame(int frame);
	void SetInterval(float interval);

	// Mise  jour de l'animation
	/* retourne true si l'animation a t mise  jour */
	bool UpdateAnim();

	// Change la texture de l'animation
	void SetAnimTexture(sf::Texture* texture);

	// Getter
	int IsPlaying() const { return m_isPlaying; }
	int GetFrameWidth() const { return m_frameWidth; }
	int GetFrameHeight() const { return m_frameHeight; }
	int GetNbRow() const { return m_nbRow; }
	int GetNbFrames() const { return m_nbFrames; }
	int GetCurrentRow() const { return m_currentRow; }
	int GetCurrentFrame() const { return m_currentFrame; }

private:
	// Proprits de l'animation
	/* Dimensions */
	int m_frameWidth;
	int m_frameHeight;
	/* Nb de frames & lignes */
	int m_nbRow;
	int m_nbFrames;
	/* Lecture courante */
	bool m_isPlaying;
	int m_currentRow;
	int m_currentFrame;
	/* Proprits */
	float m_interval;
	/* Horloge de l'animation */
	sf::Clock m_animClock;
};

