/*
** Copyright (C) 2012 Lacroix Thomas
** 
** This program is free software; you can redistribute it and/or
** modify it under the terms of the GNU Lesser General Public
** License as published by the Free Software Foundation; either
** version 2.1 of the License, or (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
** Lesser General Public License for more details.
** 
** You should have received a copy of the GNU Lesser General Public
** License along with this program; if not, write to the Free Software
** Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
*/

#include "Morpion.h"

// Ctor
Morpion::Morpion()
{
    //ctor
}

// Dtor
Morpion::~Morpion()
{
    //dtor
}

void Morpion::Connect()
{
    // Demande le nom
    std::string Nom = "";
    std::cout << "Quel est votre nom ? ";
    std::cin >> Nom;
    std::cin.ignore(10000, '\n');

    // Demande l'adresse du serveur
    sf::IpAddress Addresse;
    std::cout << "Entrez l'adresse ou le nom du serveur o\x97 se connecter : ";
    std::cin >> Addresse;
    std::cin.ignore(10000, '\n');

    // Demande le port du serveur
    unsigned short Port;
    std::cout << "Entrez le port du serveur o\x97 se connecter : ";
    std::cin >> Port;
    std::cin.ignore(10000, '\n');

    // Connecte
    Connecter(Addresse, Port);
    std::cout << "Connect\x82 au serveur \x85 " << Addresse << " !" << std::endl;

    // Attend que le client reoive son ID
    std::cout << "En attente de la r\x82""ception de l'ID du client." << std::endl;
	while (!IsIDRecu()) sf::sleep(sf::milliseconds(100));

    // Envoie le nom au serveur
    EnvoyerNom(Nom);
    std::cout << "Nom envoy\x82 au thread d'envoi." << std::endl;

    // Lance le thread de jeu et attend qu'il se termine
    Lancer();
}

void Morpion::Run()
{
	// TODO: ...
	//return;

    // Fentrage
    sf::RenderWindow App(sf::VideoMode(300, 340, 32), "Morpion");
    App.setFramerateLimit(60);
    sf::Event Evenements;

    // Formes
	sf::RectangleShape LigneVer1	(sf::Vector2f(20, 300));//100,  40, 100, 340, 3, sf::Color::Black);
    sf::RectangleShape LigneVer2	(sf::Vector2f(20, 300));//200,  40, 200, 340, 3, sf::Color::Black);
    sf::RectangleShape LigneHorMenu (sf::Vector2f(300, 20));//  0,  40, 300,  40, 3, sf::Color::Black);
    sf::RectangleShape LigneHor1	(sf::Vector2f(300, 20));//  0, 140, 300, 140, 3, sf::Color::Black);
    sf::RectangleShape LigneHor2	(sf::Vector2f(300, 20));//  0, 240, 300, 240, 3, sf::Color::Black);
		LigneVer1.setPosition(100, 200);
		LigneVer2.setPosition(10, 20);
		LigneHorMenu.setPosition(10, 20);
		LigneHor1.setPosition(10, 20);
		LigneHor2.setPosition(10, 20);
    sf::CircleShape PionJaune(40.f);//0, 0, 40, sf::Color::Yellow);
    sf::CircleShape PionRouge(40.f);//0, 0, 40, sf::Color::Red);

    // Tableau de jeu + initialisation
    std::vector< std::vector<int> > TableauPions(3, std::vector<int>(3, 0));

    // Tests du rseau
    sf::Color colEfface(255, 255, 255);

    //int gagnant = 0, aQuiLeTour = 1; // 1 = Joueur1 && 2 = Joueur 2 / IA
    //int nbJoueur = 1; // 0; // num du joueur -> jeu reseau oblige
    bool partieFinie = false, pause = true;
    while (App.isOpen() && !partieFinie)
    {
        // Evnements
        while (App.waitEvent(Evenements))
        {
            if (Evenements.type == sf::Event::Closed)
                App.close();
			
            if (Evenements.type == sf::Event::GainedFocus)
                pause = false;
            if (Evenements.type == sf::Event::LostFocus)
                pause = true;

            // Test de Send
            if (Evenements.type == sf::Event::KeyReleased)
            {
                sf::Packet paquet;
                paquet << 2 << this->GetID() << 0 << 25 << 25 << 25;//;sf::Randomizer::Random(0,255) << sf::Randomizer::Random(0,255) << sf::Randomizer::Random(0,255);
                Envoyer(paquet);
            }
            // Network event
            if (IsNouveauPaquetRecu() == true)
            {
                SetPaquetLu();

                // TODO: Fonction de traitement des paquets !
                // Test rseau -> 2, ID, 3, #, #, #
                sf::Packet paquet = GetPaquet();
                int x1, x2, x3, x4, x5, x6;
                paquet >> x1 >> x2 >> x3;

                if (x1 == 2 && x3 == 0) // Couleur d'effacage (2 >> ID >> 0 >> R >> G >> B)
                {
                    std::cout << "Paquet contenant la couleur d'effacage." << std::endl;
                    paquet >> x4;
                    paquet >> x5;
                    paquet >> x6;
                    colEfface = sf::Color(x4, x5, x6);
                }
                else if (x1 == 2 && x3 == 1) // Case joue (2 >> ID >> 1 >> x >> y)
                {
                    std::cout << "Paquet contenant la position du jeu de l'autre joueur." << std::endl;
                    paquet >> x4;
                    paquet >> x5;
                    if (TableauPions.at(x4).at(x5) != 1) // TODO: Au lieu de 0, 1, 2 pour les joueurs, faire 0, #, # o # correspond  l'index du client dans le serveur
                        TableauPions.at(x4).at(x5) = 2;
                }
            }
		
            // Joueur joue
            if (Evenements.type == sf::Event::MouseButtonPressed)// && Evenements.MouseButton == sf::Event::Left)
            {
                // Calculer les coordones de la case o le joueur a jou
				int x = sf::Mouse::getPosition(App).x / 100;
                int y = (sf::Mouse::getPosition(App).y - 40) / 100;
                TableauPions.at(x).at(y) = 1;

                // Envoie les coordones  tous les clients
                sf::Packet packet;
                packet << 2 << this->GetID() << 1 << x << y;
                Envoyer(packet);
            }
        }

        // Calculs du jeu...
        if (!pause)
        {
            //...
        } // Fin de la pause
		
        // Affichage
        App.clear();
		
        // Affiche les lignes
        App.draw(LigneHorMenu);
        App.draw(LigneHor1);
        App.draw(LigneHor2);
        App.draw(LigneVer1);
        App.draw(LigneVer2);

        // Affiche les pions
        sf::Shape *pion = NULL;
        for (unsigned int i = 0; i < 3; ++i)
        {
            for (unsigned int j = 0; j < 3; ++j)
            {
                if (TableauPions.at(i).at(j) == 0) // Vide
                    continue;
                else if (TableauPions.at(i).at(j) == 1) // Jaune
                    pion = &PionJaune;
                else if (TableauPions.at(i).at(j) == 2) // Rouge
                    pion = &PionRouge;

                pion->setPosition(i * 100.f + 50.f, j * 100.f + 40.f + 50.f);
                App.draw(*pion);
            }
        }
		
        // Affiche le rendu  l'cran
        App.display();
    }

    // Le thread de jeu quitte
    std::cout << "Le thread de jeu s'est arr\x88""t\x82 !" << std::endl;
}
