/*
** Copyright (C) 2012 Lacroix Thomas
** 
** This program is free software; you can redistribute it and/or
** modify it under the terms of the GNU Lesser General Public
** License as published by the Free Software Foundation; either
** version 2.1 of the License, or (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
** Lesser General Public License for more details.
** 
** You should have received a copy of the GNU Lesser General Public
** License along with this program; if not, write to the Free Software
** Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
*/

#pragma once
#include "AABB.h"

// Lire le .pdf dans "../doc" pour plus d'infos

class OBB : public AABB
	{
	public:
		AABB outLineRect; // Boite englobante
		double angle; // En degre

		OBB(double oX = 0.f, double oY = 0.f, double w = 1.f, double h = 1.f, double angle = 0.f);
		virtual ~OBB(void);
		
		void SetAngle(double new_angle);

		friend bool Collision(OBB* pRect1, OBB* pRect2);

	private:
		void UpdateOutLineRect_private();
		void RotateAround_private(const OBB* base);
	};