/*
** Copyright (C) 2012 Lacroix Thomas
** 
** This program is free software; you can redistribute it and/or
** modify it under the terms of the GNU Lesser General Public
** License as published by the Free Software Foundation; either
** version 2.1 of the License, or (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
** Lesser General Public License for more details.
** 
** You should have received a copy of the GNU Lesser General Public
** License along with this program; if not, write to the Free Software
** Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
*/

#pragma once
#include <SFML\Graphics.hpp>
#include "Defines.h"
#include "ImgAnim.h"
#include "AABB.h"

class Tile : public ImgAnim
{
public:
	Tile(sf::Texture *texture);
	virtual ~Tile(void);

	// Joue sur la vie
	void SetLife(int life);
	int GetLife() const { return m_life; }

	// Masquage de la mise  jour de l'anim de la Tile (par rapport  ImgAnim)
	bool UpdateAnim();

	// Getter / Setter
	bool IsBlocking() const { return m_isBlocking; }
	void SetBlocking(bool b) { m_isBlocking = b; }
	bool IsHoverable() const { return m_isHoverable; }
	void SetHoverable(bool h) { m_isHoverable = h; }
	bool IsBreakable() const { return m_isBreakable; }
	void SetBreakable(bool b) { m_isBreakable = b; }

private:
	// Proprits de la Tile
	bool m_isBlocking; // Si le tank peut passer par dessus
	bool m_isBreakable; // Si la tile est destructible
	bool m_isHoverable; // Si les bombes peuvent le survoler
	int m_life;
};