/*
** Copyright (C) 2012 Lacroix Thomas
** 
** This program is free software; you can redistribute it and/or
** modify it under the terms of the GNU Lesser General Public
** License as published by the Free Software Foundation; either
** version 2.1 of the License, or (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
** Lesser General Public License for more details.
** 
** You should have received a copy of the GNU Lesser General Public
** License along with this program; if not, write to the Free Software
** Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
*/

// Cache la console
//#pragma comment(linker, "/subsystem:windows /ENTRY:mainCRTStartup")

#include <SFML/Graphics.hpp>
#include <iostream>
#include <vector>
#include "Defines.h"
#include "GUI.h"
#include "Game.h"
#include "NetGame.h"
#include "Morpion.h"

int main()
{
	// Cration de la fentre de rendu
	sf::RenderWindow App(sf::VideoMode(SCREEN_WIDTH, SCREEN_HEIGHT, 32), "Galaxy Games - Tanks : Menu");
	App.setFramerateLimit(60);
	sf::RenderTexture renderTex;
	renderTex.create(SCREEN_WIDTH, SCREEN_HEIGHT);
	sf::Sprite renderSpr(renderTex.getTexture());

	// Cration du HUD (affichage tte haute)
	sf::Font font;
	font.loadFromFile("img/HUD.ttf");

	sf::Text txtTitre("Galaxy Games - Tanks", font, 65U);
	txtTitre.setStyle(sf::Text::Bold);
	txtTitre.setPosition(SCREEN_WIDTH / 2 - txtTitre.getGlobalBounds().width / 2.f, 50.f);
	txtTitre.setColor(sf::Color(57, 95, 255));

	std::vector<sf::Text> choix;
	choix.push_back(sf::Text("Jouer  deux", font, 50U));
	choix.push_back(sf::Text("Jouer en rseau", font, 50U));
	choix.push_back(sf::Text("Jouer au morpion", font, 50U));
	choix.push_back(sf::Text("Aide", font, 50U));
	choix.push_back(sf::Text("Quitter", font, 50U));

	for (unsigned int i = 0; i < choix.size(); ++i)
	{
		choix.at(i).setPosition(static_cast<float>(SCREEN_WIDTH / 2 - choix.at(i).getGlobalBounds().width / 2), 
			static_cast<float>(SCREEN_HEIGHT / 2 - (choix.size() - i) * 56) + 30.f);
		choix.at(i).setStyle(sf::Text::Bold);
	}

	sf::Texture texFond;
	texFond.loadFromFile("img/ground.jpg");
	sf::Sprite spriteFond(texFond);

	// Affichage du fond
	renderTex.clear();
	for (unsigned int i = 0; i < App.getSize().x / texFond.getSize().x + 1; ++i)
	{
		for (unsigned int j = 0; j < App.getSize().y / texFond.getSize().y + 1; ++j)
		{
			spriteFond.setPosition(static_cast<float>(i * texFond.getSize().x), static_cast<float>(j * texFond.getSize().y));
			renderTex.draw(spriteFond);
		}
	}
	renderTex.display();

	// Variables du menu
	unsigned int current = 0;

	// Excution de la boucle principale
	while (App.isOpen())
	{
		// Traitement des vnements
		sf::Event Event;
		while (App.pollEvent(Event))
		{
			// Fentre ferme : on quitte
			if (Event.type == sf::Event::Closed || ((Event.type == sf::Event::KeyPressed) && (Event.key.code == sf::Keyboard::Escape)))
				App.close();

			// Flche haut
			if ((Event.type == sf::Event::KeyPressed) && (Event.key.code == sf::Keyboard::Up))
			{
				if (current == 0)
					current = choix.size() - 1;
				else
					current--;
			}

			// Flche bas
			if ((Event.type == sf::Event::KeyPressed) && (Event.key.code == sf::Keyboard::Down))
				if (++current >= choix.size())
					current = 0;

			// Touche Entre
			if ((Event.type == sf::Event::KeyPressed) && (Event.key.code == sf::Keyboard::Return))
			{
				if (choix.at(current).getString() == "Jouer  deux")
				{
					App.setTitle("Galaxy Games - Tanks : Jeu 1 PC");
					Game::Play(App);
					App.setTitle("Galaxy Games - Tanks : Menu");
					App.setView(App.getDefaultView());
				}
				else if (choix.at(current).getString() == "Jouer en rseau")
				{
					//GUI::TextBox(App);

					// Demande le nom
					std::string Nom = "";
					std::cout << "Quel est votre nom ? ";
					std::cin >> Nom;
					std::cin.ignore(10000, '\n');

					// Demande l'adresse du serveur
					sf::IpAddress Adresse;
					do {
						std::cout << "Entrez l'adresse ou le nom du serveur o\x97 se connecter : ";
						std::cin >> Adresse;
					} while (Adresse == sf::IpAddress::None);
					std::cin.ignore(10000, '\n');

					// Demande le port du serveur
					unsigned short Port = 21396;
					/*std::cout << "Entrez le port du serveur o\x97 se connecter : ";
					std::cin >> Port;
					std::cin.ignore(10000, '\n');*/

					// Cre le jeu + connecte
					//Exemple JeuExemple;
					NetGame Jeu;
					Jeu.Connecter(Adresse, Port);
					std::cout << "Connect\x82 au serveur \x85 " << Adresse << " !" << std::endl;

					// Attend que le client reoive son ID
					std::cout << "En attente de la r\x82""ception de l'ID du client." << std::endl;
					while (!Jeu.IsIDRecu()) sf::sleep(sf::milliseconds(100));

					// Envoie le nom au serveur
					Jeu.EnvoyerNom(Nom);
					std::cout << "Nom envoy\x82 au thread d'envoi." << std::endl;

					// Lance le thread de jeu et attend qu'il se termine
					App.setTitle("Galaxy Games - Tanks : Jeu en rseau");
					Jeu.SetRenderWindow(&App);
					Jeu.Lancer();
					App.setTitle("Galaxy Games - Tanks : Menu");
				}
				else if (choix.at(current).getString() == "Jouer au morpion")
				{
					App.setTitle("Galaxy Games - Tanks : Morpion !");
					Morpion jeu;
					jeu.Connect(); // Lance le jeu
					App.setTitle("Galaxy Games - Tanks : Menu");
					App.setView(App.getDefaultView());
				}
				else if (choix.at(current).getString() == "Quitter")
					App.close();
			}
		}

		// Change les couleurs des choix
		for (unsigned int i = 0; i < choix.size(); ++i)
		{
			if (current == i) // Courent
				choix.at(i).setColor(sf::Color(0, 160, 226));
			else
				choix.at(i).setColor(sf::Color(0, 113, 167));
		}

		// Efface l'cran (remplissage avec du blanc)
		App.clear(sf::Color::White);

		// Affichage du fond
		App.draw(renderSpr);

		// Affichage du titre et des options
		App.draw(txtTitre);
		for (unsigned int i = 0; i < choix.size(); ++i)
			renderTex.draw(choix.at(i));

		// Affichage du contenu de la fentre  l'cran
		App.display();
	}
	return EXIT_SUCCESS;
}