/*
** Copyright (C) 2012 Lacroix Thomas
** 
** This program is free software; you can redistribute it and/or
** modify it under the terms of the GNU Lesser General Public
** License as published by the Free Software Foundation; either
** version 2.1 of the License, or (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
** Lesser General Public License for more details.
** 
** You should have received a copy of the GNU Lesser General Public
** License along with this program; if not, write to the Free Software
** Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
*/

#include <SFML/Network.hpp>
#include <string>

#ifndef INFOSCLIENT_H
#define INFOSCLIENT_H

namespace Moteur
{
    class InfosClient
    {
    public:
        InfosClient();
        InfosClient(int id, const std::string& nom, sf::IpAddress adresse);
        InfosClient(int id, const std::string& nom, const std::string& adresse);
        virtual ~InfosClient();

        // Fonctions "Set"
        void SetID(int id) { m_ID = id; }
        void SetNom(const std::string& nom) { m_Nom = nom; }
        void SetAdresseIP(sf::IpAddress adresse) { m_AdresseIP = adresse; }
        void SetAdresseIP(const std::string& adresse) { m_AdresseIP = adresse; }

        // Fonctions "Get"
        int GetID() const { return m_ID; }
        const std::string& GetNom() const { return m_Nom; }
        const sf::IpAddress& GetAdresseIP() const { return m_AdresseIP; }

    protected:

    private:
        int m_ID;
        std::string m_Nom;
        sf::IpAddress m_AdresseIP;
    };
}

#endif // INFOSCLIENT_H
