/*
** Copyright (C) 2012 Lacroix Thomas
** 
** This program is free software; you can redistribute it and/or
** modify it under the terms of the GNU Lesser General Public
** License as published by the Free Software Foundation; either
** version 2.1 of the License, or (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
** Lesser General Public License for more details.
** 
** You should have received a copy of the GNU Lesser General Public
** License along with this program; if not, write to the Free Software
** Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
*/

#include "ThreadEnvoi.h"

namespace Moteur
{
// Ctor
ThreadEnvoi::ThreadEnvoi(Moteur::Client* client)
{
    m_Client = client;
    m_ListePaquets = new std::queue<sf::Packet>;
}

// Dtor
ThreadEnvoi::~ThreadEnvoi()
{
    delete m_Client;
    delete m_ListePaquets;
}

// Envoie $paquet au serveur
bool ThreadEnvoi::Envoyer(const sf::Packet& paquet, bool bloquant)
{
    // COPIE le paquet, sa taille et indique qu'il y en a un nouveau  envoyer
    m_ListePaquets->push(paquet);

    this->launch(); // Qui lance Run() dans un nouveau thread
    if (bloquant) this->wait(); // Attend que l'envoie se termine si le thread est bloquant

    // Tout s'est bien droul
    return true;
}

// Envoie m_Paquet au serveur
void ThreadEnvoi::Run()
{
    // Si il y a un paquet  envoyer
    if (m_ListePaquets->size() != 0)
    {
        for (unsigned int i = 0; i < m_ListePaquets->size(); ++i)
        {
            if (m_ListePaquets->front().getDataSize() != 0)
            {
                // Envoyer le paquet
                sf::Socket::Status Retour = m_Client->GetServeur().send(m_ListePaquets->front());
                if (Retour == sf::Socket::Done)
                {
#ifdef NET_DEBUG
                    std::cout << "Paquet correctement envoy\x82 au serveur !" << std::endl;
#endif
                }
                else // Erreur
                {
                    std::cout << "ERREUR durant l'envoi du paquet !" << std::endl;
                }

                // Paquet envoy, on le supprime
                m_ListePaquets->pop();
            }
        }
#ifdef NET_DEBUG
        // On saute une ligne pour faire propre
        std::cout << std::endl;
#endif
    }
}

} // Fin du namespace Moteur
