/*
** Copyright (C) 2012 Lacroix Thomas
** 
** This program is free software; you can redistribute it and/or
** modify it under the terms of the GNU Lesser General Public
** License as published by the Free Software Foundation; either
** version 2.1 of the License, or (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
** Lesser General Public License for more details.
** 
** You should have received a copy of the GNU Lesser General Public
** License along with this program; if not, write to the Free Software
** Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
*/

#include <SFML/Network.hpp>
#include <iostream>
#include <string>
#include <queue>
#include "Client.h"
#include "../Threadsf.h"

#ifndef THREADENVOI_H
#define THREADENVOI_H

namespace Moteur
{
    class Client;
    class ThreadEnvoi : public Threadsf
    {
    public:
        ThreadEnvoi(Moteur::Client* client);
        virtual ~ThreadEnvoi();

        bool Envoyer(const sf::Packet& paquet, bool bloquant = false);

    protected:

    private:
        virtual void Run();

        Moteur::Client* m_Client;

        std::queue<sf::Packet>* m_ListePaquets;
    };
} // Fin du namespace Moteur

#endif // THREADENVOI_H
